#include <cnet.h>

/*  Note, that this file is written in "old" K&R C to exercise the use of
    cnet -d -k -C fast.c FAST
 */

static	int	TXframes = 0,	TXbytes = 0,
		RXframes = 0,	RXbytes = 0;

void reboot_node(ev, ts, data) CnetEvent ev; CnetTimestamp ts; CnetData data;
{
    static void appl_ready	_PARAMS((CnetEvent, CnetTimestamp, CnetData));
    static void physical_ready	_PARAMS((CnetEvent, CnetTimestamp, CnetData));
    static void stats		_PARAMS((CnetEvent, CnetTimestamp, CnetData));

    (void)CNET_set_handler( EV_PHYSICALREADY,		physical_ready, 0);
    if(nodeinfo.nodetype == NT_HOST) {
	(void)CNET_set_handler( EV_APPLICATIONREADY,	appl_ready, 0);
	(void)CNET_enable_application(ALLNODES);
	(void)CNET_set_debug_string(EV_DEBUG1," Stats ");
	(void)CNET_set_handler( EV_DEBUG1,	stats, 0);
    }
}

void physical_ready(ev, ts, data) CnetEvent ev; CnetTimestamp ts; CnetData data;
{
    char	frame[MAX_MESSAGE_SIZE];
    int		link, len;

    len		= sizeof(frame);
    (void)CNET_read_physical(&link,frame,&len);
    (void)CNET_write_application(frame,&len);
    RXframes++;	RXbytes += len;
}

void appl_ready(ev, ts, data) CnetEvent ev; CnetTimestamp ts; CnetData data;
{
    char	frame[MAX_MESSAGE_SIZE];
    CnetAddr	destaddr;
    int		len;

    len	= sizeof(frame);
    (void)CNET_read_application(&destaddr,frame,&len);
    (void)CNET_write_direct(destaddr,frame,&len);
    TXframes++;	TXbytes += len;
}

void stats(ev, ts, data) CnetEvent ev; CnetTimestamp ts; CnetData data;
{
    (void)printf("\tTXframes %4d, TXbytes %8d\n\tRXframes %4d, RXbytes %8d\n\n",
		    TXframes, TXbytes, RXframes, RXbytes);
}
